#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <fstream>
#include <array>
#include <functional>
#include <stack>
#include <memory>
using namespace std;
#define int long long
#define ii pair <int, int>
#define app push_back
#define all(a) a.begin(), a.end()
#define bp __builtin_popcountll
#define ll long long
#define mp make_pair
#define x first
#define y second
#define Time (double)clock()/CLOCKS_PER_SEC
#define munq(a) sort(all(a)); a.resize(unique(all(a))-a.begin())
#define sz(a) ((int)a.size())

#ifdef LOCAL
#define debug(...) [](auto...a){ ((cerr << a << ' '), ...) << endl; }(#__VA_ARGS__, ":", __VA_ARGS__)
#else
#define debug(...)
#endif

#define FORI(i,a,b) for (int i = (a); i < (b); ++i)
#define FOR(i,a) FORI(i,0,a)
#define ROFI(i,a,b) for (int i = (b)-1; i >= (a); --i)
#define ROF(i,a) ROFI(i,0,a)
#define rep(a) FOR(_,a)
#define each(a,x) for (auto& a: x)
#define FORN(i, n) FORI(i, 1, n + 1)

using vi = vector<int>;
template <typename T>
std::istream& operator >>(std::istream& input, std::pair <T, T> & data)
{
    input >> data.x >> data.y;
    return input;
}
template <typename T>
std::istream& operator >>(std::istream& input, std::vector<T>& data)
{
    for (T& x : data)
        input >> x;
    return input;
}
template <typename T>
std::ostream& operator <<(std::ostream& output, const pair <T, T> & data)
{
    output << "(" << data.x << "," << data.y << ")";
    return output;
}
template <typename T>
std::ostream& operator <<(std::ostream& output, const std::vector<T>& data)
{
    for (const T& x : data)
        output << x << " ";
    return output;
}
ll div_up(ll a, ll b) { return a/b+((a^b)>0&&a%b); } // divide a by b rounded up
ll div_down(ll a, ll b) { return a/b-((a^b)<0&&a%b); } // divide a by b rounded down 
ll math_mod(ll a, ll b) { return a - b * div_down(a, b); }
#define tcT template<class T
#define tcTU tcT, class U
tcT> using V = vector<T>; 
tcT> bool ckmin(T& a, const T& b) {
    return b < a ? a = b, 1 : 0; 
} // set a = min(a,b)
tcT> bool ckmax(T& a, const T& b) {
    return a < b ? a = b, 1 : 0; 
}
tcT> vector <T> presum(vector <T> &a) {
    vector <T> p(a.size() + 1);
    FOR (i, a.size()) {
        p[i + 1] = p[i] + a[i];
    }   
    return p;
}
tcT> vector <T> sufsum(vector <T> &a) {
    vector <T> p(a.size() + 1);
    for (int i = (int)a.size() - 1; i >= 0; --i) {
        p[i] = p[i + 1] + a[i];
    }
    return p;
}
ll gcd(ll a, ll b) {
    while (b) {
        tie(a, b) = mp(b, a % b);
    }
    return a;
}
int Bit(int mask, int bit) { return (mask >> bit) & 1; }
signed main() {
    #ifdef LOCAL
    #else
    #define endl '\n'
    ios_base::sync_with_stdio(0); cin.tie(0);
    #endif
    auto solve = [&] () {
    	int n, m;
    	cin >> n >> m;
    	vector <vector <int> > g(n);
    	for (int i = 0; i < m; ++i) {
    		int u, v; cin >> u >> v;
    		u--; v--;
    		g[u].app(v); g[v].app(u);
    	}
    	if (n & 1) {
    		cout << "-1\n";
    		return;
    	}
        vector <int> ans(n, 1), used(n), par(n), cnt(n), dist(n), comp;
        int color = 2;
        queue <int> q;
        q.push(0);
        int num = 0;
        while (!q.empty()) {
            int s = q.front(); q.pop();
            comp.clear();
            num++;
            function <void(int)> dfs = [&] (int u) {
                comp.app(u);
                used[u] = num;
                for (int v : g[u]) {
                    if (ans[v] == ans[u] && used[v] < num) {
                        dfs(v);
                    }
                }
            };
            dfs(s);
            for (int u : comp) {
                int deg = 0;
                for (int v : g[u]) {
                    if (ans[u] == ans[v]) {
                        deg++;
                    }
                }
                if (deg % 2 == 0) {
                    queue <int> qq;
                    qq.push(u);
                    par[u] = u;
                    vector <int> ord;
                    for (int a : comp) {
                        dist[a] = n;
                    }
                    dist[u] = 0;
                    while (!qq.empty()) {
                        int a = qq.front(); qq.pop();
                        ord.app(a);
                        for (int b : g[a]) {
                            if (ans[a] == ans[b]) {
                                if (dist[a] + 1 < dist[b]) {
                                    dist[b] = dist[a] + 1;
                                    qq.push(b);
                                    par[b] = a;
                                }
                            }
                        }
                    }
                    reverse(all(ord));
                    for (int a : ord) {
                        cnt[a] = 0;
                    }
                    for (int a : ord) {
                        cnt[a]++;
                        if (u != a) {
                            cnt[par[a]] += cnt[a];
                            if (cnt[a] % 2 == 0) {
                                par[a] = a;
                                ans[a] = color++;
                                q.push(a);
                            }
                        }
                    }
                    q.push(u);
                    reverse(all(ord));
                    for (int a : ord) {
                        ans[a] = ans[par[a]];
                    }
                    break;
                }
            }

        }

        cout << ans << '\n';
    };
    int t;
    cin >> t;
    rep (t) {
        solve();
    }
}